Index: trunk/examples/extended/electromagnetic/TestEm7/include/c2_function.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/c2_function.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/c2_function.hh	(revision 1230)
@@ -316,17 +505,265 @@
     /// to allow very efficient recursion.
     /// \param rb a pointer to the recur struct.
-	float_type integrate_step(struct c2_integrate_recur &rb) const;
+	float_type integrate_step(struct c2_integrate_recur &rb) const throw(c2_exception);
     
-    /// these carry a memory of the last root bracketing,
+    /// \brief Carry out the recursive subdivision for sampling.
+    ///
+    /// This passes information recursively through the \a recur block pointer
+    /// to allow very efficient recursion.
+    /// \param rb a pointer to the recur struct.
+	void sample_step(struct c2_sample_recur &rb) const throw(c2_exception);
+
+    /// this carry a memory of the last root bracketing,
     /// to avoid the necessity of evaluating the function on the brackets every time
     /// if the brackets have not been changed. 
-    mutable float_type lastRootLowerX, lastRootUpperX, lastRootLowerY, lastRootUpperY;
-    mutable int rootInitialized;
-	
-};
-
+	/// it is declared as a pointer, since many c2_functions may never need one allocated
+    mutable struct  c2_root_info *root_info;
+	
+	mutable size_t owner_count;
+};
+
+/// \brief a container into which any conventional c-style function can be dropped,
+/// to create a degenerate c2_function without derivatives. 
+/// Mostly useful for sampling into interpolating functions.
+/// construct a reference to this with c2_classic_function()
+/// \ingroup containers
+/// The factory function c2_factory::classic_function() creates *new c2_classic_function_p()
+template <typename float_type=double> class c2_classic_function_p : public c2_function<float_type> {
+public:
+	/// \brief construct the container 
+	/// \param c_func a pointer to a conventional c-style function
+	c2_classic_function_p(const float_type (*c_func)(float_type)) : c2_function<float_type>(), func(c_func)  {}
+
+	/// \copydoc c2_function::value_with_derivatives
+	/// Uses the internal function pointer set by set_function().
+	virtual float_type value_with_derivatives(float_type x, float_type *yprime, float_type *yprime2) const throw(c2_exception) 
+	{
+		if(!func) throw c2_exception("c2_classic_function called with null function");
+		if(yprime) *yprime=0;
+		if(yprime2) *yprime2=0;
+		return func(x); 
+	}
+	~c2_classic_function_p() { }
+	
+protected:
+	/// \brief pointer to our function
+	const float_type (*func)(float_type);
+};
+
+/// \brief create a container for a c2_function which handles the reference counting.
+/// \ingroup containers
+/// It is useful as a smart container to hold a c2_function and keep the reference count correct.  
+/// The recommended way for a class to store a c2_function which is handed in from the outside 
+/// is for it to have a c2_ptr member into which the passed-in function is stored.
+/// This way, when the class instance is deleted, it will automatically dereference any function
+/// which it was handed.
+///
+/// This class contains a copy constructor and operator=, to make it fairly easy to make 
+/// a std::vector of these objects, and have it work as expected.
+template <typename float_type> class c2_const_ptr {
+public:
+	/// \brief construct the container with no function
+	c2_const_ptr() : func(0)  {}
+	/// \brief construct the container with a pre-defined function
+	/// \param f the function to store
+	c2_const_ptr(const c2_function<float_type> &f) : func(0) 
+		{ set_function(&f); }
+	/// \brief copy constructor
+	/// \param src the container to copy
+	c2_const_ptr(const c2_const_ptr<float_type> &src) : func(0)
+		{ set_function(src.get_ptr()); }
+	/// \brief fill the container with a new function, or clear it with a null pointer
+	/// \param f the function to store, releasing any previously held function
+	void set_function(const c2_function<float_type> *f) 
+	{ 
+		if(func) func->release_ownership();
+		func=f; 
+		if(func) func->claim_ownership();
+	}
+	
+	/// \brief fill the container from another container
+	/// \param f the container to copy
+	void operator =(const c2_const_ptr<float_type> &f) 
+		{ set_function(f.get_ptr()); }
+	/// \brief fill the container with a function
+	/// \param f the function
+	void operator =(const c2_function<float_type> &f) 
+		{ set_function(&f); }
+	/// \brief release the function without destroying it, so it can be returned from a function
+	///
+	/// This is usually the very last line of a function before the return statement, so that 
+	/// any exceptions that happen during execution of the function will cause proper cleanup.
+	/// Once the function has been released from its container this way, it is an orhpaned object
+	/// until the caller claims it, so it could get lost if an exception happens.
+	void release_for_return() throw(c2_exception)
+		{	
+			if(func) func->release_ownership_for_return();
+			func=0;
+		}
+	/// \brief clear the function
+	///
+	/// Any attempt to use this c2_plugin_function_p throws an exception if the saved function is cleared.
+	void unset_function(void) { set_function(0);  }
+	/// \brief destructor
+	~c2_const_ptr() { set_function(0); }
+	
+	/// \brief get a reference to our owned function
+	inline const c2_function<float_type> &get() const throw(c2_exception) 
+	{ 
+		if(!func) throw c2_exception("c2_ptr accessed uninitialized");
+		return *func;
+	}
+	/// \brief get an unchecked pointer to our owned function
+	inline const c2_function<float_type> *get_ptr() const { return func; }
+	/// \brief get a checked pointer to our owned function
+	inline const c2_function<float_type> *operator -> () const 
+		{ return &get(); }
+	/// \brief check if we have a valid function
+	bool valid() const { return func != 0; }
+	
+	/// \brief type coercion operator which lets us use a pointer as if it were a const c2_function
+	operator const c2_function<float_type>& () const { return this->get(); }
+	
+	/// \brief convenience operator to make us look like a function
+	/// \param x the value at which to evaluate the contained function
+	/// \return the evaluated function
+	/// \note If you using this repeatedly, do const c2_function<float_type> &func=ptr;
+	/// and use func(x).  Calling this operator wastes some time, since it checks the validity of the
+	/// pointer every time.
+	float_type operator()(float_type x) const throw(c2_exception) { return get()(x); }
+	/// \brief convenience operator to make us look like a function
+	/// \param x the value at which to evaluate the contained function
+	/// \param yprime the derivative
+	/// \param yprime2 the second derivative
+	/// \return the evaluated function
+	/// \note If you using this repeatedly, do const c2_function<float_type> &func=ptr;
+	/// and use func(x).  Calling this operator wastes some time, since it checks the validity of the
+	/// pointer every time.
+	float_type operator()(float_type x, float_type *yprime, float_type *yprime2) const throw(c2_exception) 
+		{ return get().value_with_derivatives(x, yprime, yprime2); }
+	/// \brief factory function to create a c2_sum_p from a regular algebraic expression.
+	/// \param rhs the right-hand term of the sum
+	/// \return a new c2_function
+	c2_sum_p<float_type> &operator + (const c2_function<float_type> &rhs)  const throw(c2_exception)
+		{ return *new c2_sum_p<float_type>(get(), rhs); }
+	/// \brief factory function to create a c2_diff_p from a regular algebraic expression.
+	/// \param rhs the right-hand term of the difference
+	/// \return a new c2_function
+	c2_diff_p<float_type> &operator - (const c2_function<float_type> &rhs)  const throw(c2_exception)
+		{ return *new c2_diff_p<float_type>(get(), rhs); }
+	/// \brief factory function to create a c2_product_p from a regular algebraic expression.
+	/// \param rhs the right-hand term of the product
+	/// \return a new c2_function
+	c2_product_p<float_type> &operator * (const c2_function<float_type> &rhs) const throw(c2_exception)
+		{ return *new c2_product_p<float_type>(get(), rhs); }
+	/// \brief factory function to create a c2_ratio_p from a regular algebraic expression.
+	/// \param rhs the right-hand term of the ratio (the denominator)
+	/// \return a new c2_function
+	c2_ratio_p<float_type> &operator / (const c2_function<float_type> &rhs)  const throw(c2_exception)
+		{ return *new c2_ratio_p<float_type>(get(), rhs); }
+    /// \brief compose this function outside another.
+    /// \param inner the inner function
+    /// \return the composed function
+	c2_composed_function_p<float_type> & operator ()(const c2_function<float_type> &inner) const throw(c2_exception)
+		{ return *new c2_composed_function_p<float_type>(get(), inner); }
+	
+protected:
+	const c2_function<float_type> * func;
+};
+
+/// \brief create a container for a c2_function which handles the reference counting.
+/// \ingroup containers
+///
+/// \see  c2_const_ptr and \ref memory_management "Use of c2_ptr for memory management"
+
+template <typename float_type> class c2_ptr : public c2_const_ptr<float_type >
+{
+public:
+	/// \brief construct the container with no function
+	c2_ptr() : c2_const_ptr<float_type>()  {}
+	/// \brief construct the container with a pre-defined function
+	/// \param f the function to store
+	c2_ptr(c2_function<float_type> &f) : 
+		c2_const_ptr<float_type>() { set_function(&f); } 
+	/// \brief copy constructor
+	/// \param src the container to copy
+	c2_ptr(const c2_ptr<float_type> &src) : 
+		c2_const_ptr<float_type>() { set_function(src.get_ptr()); }
+	/// \brief get a checked pointer to our owned function
+	inline c2_function<float_type> &get() const throw(c2_exception) 
+		{ return *const_cast<c2_function<float_type>*>(&c2_const_ptr<float_type>::get()); }
+	/// \brief get an unchecked pointer to our owned function
+	inline c2_function<float_type> *get_ptr() const 
+		{ return const_cast<c2_function<float_type>*>(this->func); }
+	/// \brief get a checked pointer to our owned function
+	inline c2_function<float_type> *operator -> () const 
+		{ return &get(); }
+	/// \brief fill the container from another container
+	/// \param f the container to copy
+	void operator =(const c2_ptr<float_type> &f) 
+		{ set_function(f.get_ptr()); }
+	/// \brief fill the container with a function
+	/// \param f the function
+	void operator =(c2_function<float_type> &f) 
+		{ set_function(&f); }
+private:
+	/// \brief hidden non-const-safe version of operator=
+	void operator =(const c2_const_ptr<float_type> &f) { }
+	/// \brief hidden non-const-safe version of operator=
+	void operator =(const c2_function<float_type> &f) { }
+};
+
+/// \brief create a non-generic container for a c2_function which handles the reference counting.
+/// \ingroup containers
+///
+/// \see  c2_const_ptr and \ref memory_management "Use of c2_ptr for memory management"
+///
+/// \note Overuse of this class will generate massive bloat.  Use c2_ptr and c2_const_ptr if you don't _really_ need specific pointer types.
+/// \see  \ref memory_management "Use of c2_ptr for memory management"
+/*
+template <typename float_type, template <typename> class c2_class > class c2_typed_ptr : public c2_const_ptr<float_type> {
+public:
+	/// \brief construct the container with no function
+	c2_typed_ptr() : c2_ptr<float_type>()  {}
+	/// \brief construct the container with a pre-defined function
+	/// \param f the function to store
+	c2_typed_ptr(c2_class<float_type> &f)
+		: c2_const_ptr<float_type>() { this->set_function(&f); }
+	/// \brief copy constructor
+	/// \param src the container to copy
+	c2_typed_ptr(const c2_typed_ptr<float_type, c2_class> &src) 
+		: c2_const_ptr<float_type>() { this->set_function(src.get_ptr()); }
+	
+	/// \brief get a reference to our owned function
+	inline c2_class<float_type> &get() const throw(c2_exception) 
+		{ 
+			return *static_cast<c2_class<float_type> *>(const_cast<c2_function<float_type>*>(&c2_const_ptr<float_type>::get()));
+		}
+	/// \brief get a checked pointer to our owned function
+	inline c2_class<float_type> *operator -> () const 
+		{ return &get(); }
+	/// \brief get an unchecked pointer to our owned function
+	inline c2_class<float_type> *get_ptr() const 
+		{ return static_cast<c2_class<float_type> *>(const_cast<c2_function<float_type>*>(this->func)); }
+	/// \brief type coercion operator which lets us use a pointer as if it were a c2_function
+	operator c2_class<float_type>&() const { return get(); }
+	/// \brief fill the container from another container
+	/// \param f the container to copy
+	void operator =(const c2_typed_ptr<float_type, c2_class> &f) 
+		{ set_function(f.get_ptr()); }
+	/// \brief fill the container with a function
+	/// \param f the function
+	void operator =(c2_class<float_type> &f) 
+		{ set_function(&f); }
+private:
+	/// \brief hidden downcasting version of operator=
+	void operator =(const c2_const_ptr<float_type> &f) { }
+	/// \brief hidden downcasting version of operator=. Use an explicit dynamic_cast<c2_class<float_type>&>(f) if you need to try this.
+	void operator =(const c2_function<float_type> &f) { }
+};
+*/
 /// \brief a container into which any other c2_function can be dropped, to allow expressions
 /// with replacable components.  
-///
+/// \ingroup containers
 ///It is useful for plugging different InterpolatingFunctions into a c2_function expression.
 ///It saves a lot of effort in other places with casting away const declarations.
@@ -334,20 +771,26 @@
 /// It is also useful as a wrapper for a function if it is necessary to have a copy of a function
 /// which has a different domain or sampling grid than the parent function.  This can be
-/// be used, for example, to patch badly-behaved functions with c2_piecewise_function by 
+/// be used, for example, to patch badly-behaved functions with c2_piecewise_function_p by 
 /// taking the parent function, creating two plugins of it with domains on each side of the 
 /// nasty bit, and then inserting a nice function in the hole.
-template <typename float_type=double> class c2_plugin_function : public c2_function<float_type> {
+///
+/// This can also be used as a fancier c2_ptr which allows direct evaluation
+/// instead of having to dereference the container first.
+///
+/// The factory function c2_factory::plugin_function() creates *new c2_plugin_function_p()
+template <typename float_type=double> class c2_plugin_function_p : 
+	public c2_function<float_type> {
 public:
 	/// \brief construct the container with no function
-	c2_plugin_function() : c2_function<float_type>(), func(0), owns(false)  {}
+	c2_plugin_function_p() : c2_function<float_type>(), func()  {}
 	/// \brief construct the container with a pre-defined function
-	c2_plugin_function(const c2_function<float_type> &f) : c2_function<float_type>(), func(0), owns(false) { set_function(f); }
-	/// \brief fill the container with a new function
-	void set_function(const c2_function<float_type> &f) 
-		{ 
-			if(owns && func) delete func;
-			func=&f; set_domain(f.xmin(), f.xmax()); 
-			set_sampling_grid_pointer(*f.sampling_grid); 
-			owns=false;
+	c2_plugin_function_p(c2_function<float_type> &f) : 
+		c2_function<float_type>(),func(f)  { }
+	/// \brief fill the container with a new function, or clear it with a null pointer
+	/// and copy our domain
+	void set_function(c2_function<float_type> *f) 
+		{
+			func.set_function(f);
+			if(f) set_domain(f->xmin(), f->xmax());
 		}
 	/// \copydoc c2_function::value_with_derivatives
@@ -355,100 +798,103 @@
 	virtual float_type value_with_derivatives(float_type x, float_type *yprime, float_type *yprime2) const throw(c2_exception) 
 		{
-			if(!func) throw c2_exception("c2_plugin_function<float_type> called uninitialized");
-			return this->func->value_with_derivatives(x, yprime, yprime2); 
+			if(!func.valid()) throw c2_exception("c2_plugin_function_p called uninitialized");
+			return func->value_with_derivatives(x, yprime, yprime2); 
 		}
-	/// \brief clear the function
-	///
-	/// Any attempt to use this c2_plugin_function throws an exception if the saved function is cleared.
-	void unset_function(void) { if(owns && func) delete func; func=0; owns=false; }
 	/// \brief destructor
-	~c2_plugin_function() { if(owns && func) delete func; }
-	/// \brief tell us we should delete the function at destruction.  NOT sticky when function is reset
-	void set_ownership() { this->owns=true; }
-	
+	~c2_plugin_function_p() { }
+	
+	/// \brief clear our function
+	void unset_function() { func.unset_function(); }
+	
+	virtual void get_sampling_grid(float_type xmin, float_type xmax, std::vector<float_type> &grid) const 
+	{	
+		if(!func.valid()) throw c2_exception("c2_plugin_function_p called uninitialized");
+		if(this->sampling_grid) c2_function<float_type>::get_sampling_grid(xmin, xmax, grid);
+		else  func->get_sampling_grid(xmin, xmax, grid);
+	}
 protected:
-	const c2_function<float_type> *func;
-	bool owns;
-	
+	c2_ptr<float_type> func;
+};
+
+/// \brief a c2_plugin_function_p which promises not to fiddle with the plugged function.
+/// \ingroup containers
+///
+/// The factory function c2_factory::const_plugin_function() creates *new c2_const_plugin_function_p()
+template <typename float_type=double> class c2_const_plugin_function_p : public c2_plugin_function_p<float_type> {
+public:
+	/// \brief construct the container with no function
+	c2_const_plugin_function_p() : c2_plugin_function_p<float_type>()  {}
+	/// \brief construct the container with a pre-defined function
+	c2_const_plugin_function_p(const c2_function<float_type> &f) : 
+		c2_plugin_function_p<float_type>()  { set_function(&f); }
+	/// \brief fill the container with a new function, or clear it with a null pointer
+	void set_function(const c2_function<float_type> *f) 
+		{ c2_plugin_function_p<float_type>::set_function(const_cast<c2_function<float_type>*>(f)); }
+	/// \brief destructor
+	~c2_const_plugin_function_p() { }
+	
+	/// \brief get a const reference to our owned function, for direct access
+	const c2_function<float_type> &get() const throw(c2_exception) 
+		{ return this->func.get(); }
 };
 
 /// \brief Provides support for c2_function objects which are constructed from two other c2_function
 /// objects.  
-///
-/// It provides a very primitive ownership concept, so that the creator can tag a function
-/// as being owned by this function, so that when this function is deleted, the owned function will be deleted, too.
-/// This allows a piece of code to create various c2_function objects, combine them with binary operators,
-/// appropriately mark wich ones have no other possible owners, and return the final function with
-/// reasonable faith that everything will get cleaned up when the final function is deleted.  Note that
-/// none of this marking is automatic, to keep this class very lightweight.
+/// \ingroup abstract_classes
 template <typename float_type=double> class c2_binary_function : public c2_function<float_type> {
 public:
-	
-	
 	///  \brief function to manage the binary operation, used by c2_binary_function::value_with_derivatives() 
     /// 
-    /// Normally not used alone, but can be used to combine functions in other contexts. 
-	/// See interpolating_function::binary_operator() for an example.
-	/// \param left the function on the left of the binary operator or outside the composition
-	/// \param right the function to the right of the operator or inside the composition
-    /// \param[in] x the point at which to evaluate the function
-    /// \param[out] yprime the first derivative (if pointer is non-null)
-    /// \param[out] yprime2 the second derivative (if pointer is non-null)
-    /// \return the value of the function
-	virtual float_type combine(const c2_function<float_type> &left, const c2_function<float_type> &right, 
-					   float_type x, float_type *yprime, float_type *yprime2) const =0;
 	
 	virtual float_type value_with_derivatives(float_type x, float_type *yprime, float_type *yprime2) const throw (c2_exception) 
     { 
-		return this->combine(this->Left, this->Right, x, yprime, yprime2);
+		if(stub) throw c2_exception("attempt to evaluate a c2_binary_function stub");
+		return this->combine(*Left.get_ptr(), *Right.get_ptr(), x, yprime, yprime2);
     }
 
-	/// \brief allow c2_binary_function to remember ownership of contained functions for automatic cleanup
+	/// \brief destructor releases ownership of member functions
 	///
-	/// upon destruction, this will cause disposal of the left member function
-	void set_left_ownership(void) { leftown=true; }
-	/// \brief allow c2_binary_function to remember ownership of contained functions for automatic cleanup
-	///
-	/// upon destruction, this will cause disposal of the right member function
-	void set_right_ownership(void) { rightown=true; }
-	/// \brief allow c2_binary_function to remember ownership of contained functions for automatic cleanup
-	///
-	/// upon destruction, this will cause disposal of both member functions
-	void set_ownership(void) { leftown=rightown=true; }
-	/// \brief destructor executes disposal of member functions if flagged
-	///
-	/// depends on judicious use of set_ownership(), set_right_ownership(), or set_left_ownership()
-	virtual ~c2_binary_function() {
-		if(leftown) delete &Left;
-		if(rightown) delete &Right;
-	}
-		
+	virtual ~c2_binary_function() { }
+
 protected:
 	/// \brief construct the binary function
+	/// \param combiner pointer to the function which actualy knows how to execute the binary
 	/// \param left the c2_function to be used in the left side of the binary relation
 	/// \param right the c2_function to be used in the right side of the binary relation
-	c2_binary_function( const c2_function<float_type> &left,  const c2_function<float_type> &right) : 
-	c2_function<float_type>(), 
-	Left(left), Right(right), leftown(false), rightown(false) 
+	c2_binary_function( 
+			float_type (*combiner)(const c2_function<float_type> &left, const c2_function<float_type> &right, 
+				   float_type x, float_type *yprime, float_type *yprime2),						
+			const c2_function<float_type> &left,  const c2_function<float_type> &right) : 
+			c2_function<float_type>(), combine(combiner), Left(left), Right(right), stub(false)
 	{ 
-			set_domain(
-					   (left.xmin() > right.xmin()) ? left.xmin() : right.xmin(), 
-					   (left.xmax() < right.xmax()) ? left.xmax() : right.xmax()
-					   );
+		set_domain(
+				   (left.xmin() > right.xmin()) ? left.xmin() : right.xmin(), 
+				   (left.xmax() < right.xmax()) ? left.xmax() : right.xmax()
+				   );
 	} 
 	
 	/// \brief construct a 'stub' c2_binary_function, which provides access to the combine() function
 	/// \note Do not evaluate a 'stub' ever.  It is only used so that combine() can be called
-    c2_binary_function() : c2_function<float_type>(), 
-		Left(*((c2_function<float_type> *)0)), Right(*((c2_function<float_type> *)0)) {}
-	
-	const c2_function<float_type> &Left,  &Right;
-	bool leftown, rightown;
-		
+    c2_binary_function(
+	   float_type (*combiner)(const c2_function<float_type> &left, const c2_function<float_type> &right, 
+							  float_type x, float_type *yprime, float_type *yprime2)
+		) : c2_function<float_type>(), combine(combiner), Left(), Right(), stub(true) { }
+	
+public:
+	float_type (* const combine)(const c2_function<float_type> &left, const c2_function<float_type> &right, 
+								 float_type x, float_type *yprime, float_type *yprime2);
+	
+protected:	
+	const c2_const_ptr<float_type> Left,  Right;
+	/// \brief if true, we don't own any functions, we are just a source of a combining function.
+	bool stub;
+	
 };
 
 /// \brief Create a very lightweight method to return a scalar multiple of another function.
-/// 
-template <typename float_type=double> class c2_scaled_function : public c2_plugin_function<float_type> {
+/// \ingroup containers \ingroup arithmetic_functions \ingroup parametric_functions
+///
+/// The factory function c2_factory::scaled_function() creates *new c2_scaled_function_p
+template <typename float_type=double> class c2_scaled_function_p : public c2_function<float_type> {
 public:
 	/// \brief construct the function with its scale factor.
@@ -456,6 +902,6 @@
 	/// \param outer the function to be scaled
 	/// \param scale the multiplicative scale factor
-	c2_scaled_function(const c2_function<float_type> &outer, float_type scale) : 
-		c2_plugin_function<float_type>(outer), yscale(scale) { }
+	c2_scaled_function_p(const c2_function<float_type> &outer, float_type scale) : 
+		c2_function<float_type>(), func(outer), yscale(scale) { }
 	
 	/// \brief set a new scale factor
@@ -475,20 +921,24 @@
 
 protected:
-    c2_scaled_function<float_type>() {} // hide default constructor, since its use is almost always an error.
+    c2_scaled_function_p<float_type>() : func() {} // hide default constructor, since its use is almost always an error.
+	/// \brief the scaling factor for the function
+	const c2_const_ptr<float_type> func;
 	float_type yscale;
 };
 
 /// \brief A container into which any other c2_function can be dropped.
-///
+/// \ingroup containers
 /// It allows a function to be pre-evaluated at a point, and used at multiple places in an expression
 /// efficiently. If it is re-evaluated at the previous point, it returns the remembered values;
 /// otherwise, it re-evauates the function at the new point.
 ///
-template <typename float_type=double> class c2_cached_function : public c2_plugin_function<float_type> {
+/// The factory function c2_factory::cached_function() creates *new c2_cached_function_p
+template <typename float_type=double> class c2_cached_function_p : public c2_function<float_type> {
 public:
 	/// \brief construct the container
 	///
 	/// \param f the function to be cached
-	c2_cached_function(const c2_function<float_type> &f) : c2_plugin_function<float_type>(f), init(false)  {}
+	c2_cached_function_p(const c2_function<float_type> &f) : c2_function<float_type>(),
+		func(f), init(false)  {}
 	/// \copydoc c2_function::value_with_derivatives
 	///
@@ -508,5 +958,6 @@
 
 protected:
-    c2_cached_function() {} // hide default constructor, since its use is almost always an error.
+    c2_cached_function_p() : func() {} // hide default constructor, since its use is almost always an error.
+	const c2_const_ptr<float_type> func;
 	mutable bool init;
 	mutable float_type x0, y, yp, ypp;
@@ -515,9 +966,9 @@
 
 /// \brief Provides function composition (nesting)
-///
+/// \ingroup arithmetic_functions 
 /// This allows evaluation of \a f(g(x)) where \a f and \a g are c2_function objects.
 ///
-/// \note See c2_binary_function for discussion of ownership.
-template <typename float_type=double> class  c2_composed_function : public c2_binary_function<float_type> {
+/// This should always be constructed using \ref compose_operator "c2_function::operator()"
+template <typename float_type=double> class  c2_composed_function_p : public c2_binary_function<float_type> {
 public:
 	
@@ -526,23 +977,24 @@
 	/// \param outer the outer function 
 	/// \param inner the inner function
-	c2_composed_function(const c2_function<float_type> &outer, const c2_function<float_type> &inner) : c2_binary_function<float_type>(outer, inner) {}
+	c2_composed_function_p(const c2_function<float_type> &outer, const c2_function<float_type> &inner) : 
+		c2_binary_function<float_type>(combine, outer, inner) { this->set_domain(inner.xmin(), inner.xmax()); }
 	/// \brief Create a stub just for the combiner to avoid statics. 
-	c2_composed_function() : c2_binary_function<float_type>() {} ;
-
-	virtual float_type combine(const c2_function<float_type> &left, const c2_function<float_type> &right, 
-						  float_type x, float_type *yprime, float_type *yprime2) const
+	c2_composed_function_p() : c2_binary_function<float_type>(combine) {} 
+
+	/// \brief execute math necessary to do composition
+	static float_type combine(const c2_function<float_type> &left, const c2_function<float_type> &right, 
+						  float_type x, float_type *yprime, float_type *yprime2) throw(c2_exception)
     {
-		float_type y0, yp0, ypp0, y1, yp1, ypp1;
-		float_type *yp0p, *ypp0p, *yp1p, *ypp1p;
+		float_type y0, y1;
 		if(yprime || yprime2) {
-			yp0p=&yp0; ypp0p=&ypp0; yp1p=&yp1; ypp1p=&ypp1;
+			float_type yp0, ypp0, yp1, ypp1;
+			y0=right.value_with_derivatives(x, &yp0, &ypp0);
+			y1=left.value_with_derivatives(y0, &yp1, &ypp1);
+			if(yprime) *yprime=yp1*yp0;
+			if(yprime2) *yprime2=ypp0*yp1+yp0*yp0*ypp1;
 		} else {
-			yp0p=ypp0p=yp1p=ypp1p=0;
+			y0=right(x);
+			y1=left(y0);
 		}
-		
-		y0=right.value_with_derivatives(x, yp0p, ypp0p);
-		y1=left.value_with_derivatives(y0, yp1p, ypp1p);
-		if(yprime) *yprime=yp1*yp0;
-		if(yprime2) *yprime2=ypp0*yp1+yp0*yp0*ypp1;
 		return y1;
 	}	
